#include "SpielerGUI.h"
#include "../../Initialisierung/Initialisierung.h"
#include <MausEreignis.h>
#include <Rahmen.h>
#include <Fortschritt.h>

using namespace Framework;

int getStellen( double d )
{
	int ret = 0;
	for( int i = 1; d >= i; i *= 10 )
		ret++;
	return ret;
}

// Inhalt der Ship Klasse aus Ship.h
// Konstruktor
SpielerGUI::SpielerGUI( Schrift *zSchrift )
{
	ram = new LRahmen();
	ram->setSize( 200, 332 );
	ram->setPosition( Punkt( BildschirmGre().x - 210, 10 ) );
	ram->setFarbe( 0xFFFFFFFF );
	spieler = initTextFeld( 5, 5, 190, 20, zSchrift, TextFeld::Style::Text | TextFeld::Style::Center, "" );
	stabilitt = initTextFeld( 5, 30, 165, 20, zSchrift, TextFeld::Style::Text | TextFeld::Style::Center, "" );
	energie = initTextFeld( 5, 55, 165, 20, zSchrift, TextFeld::Style::Text | TextFeld::Style::Center, "" );
	stabilittB = new FBalken();
	stabilittB->setPosition( 5, 30 );
	stabilittB->setSize( 165, 20 );
	stabilittB->setHintergrundFarbe( 0xFF000000 );
	stabilittB->setFBgFarbe( 0xFF55FF55 );
	stabilittB->setLinienRahmenFarbe( 0xFF00FF00 );
	stabilittB->setLinienRahmenBreite( 1 );
	stabilittB->setFRFarbe( 0xFF00FF00 );
	stabilittB->setFRBreite( 1 );
	stabilittB->setStyle( FBalken::Style::Sichtbar | FBalken::Style::L_R | FBalken::Style::Hintergrund | FBalken::Style::FFarbe | FBalken::Style::Rahmen | FBalken::Style::FRahmen );
	energieB = new FBalken();
	energieB->setPosition( 5, 55 );
	energieB->setSize( 165, 20 );
	energieB->setHintergrundFarbe( 0xFF000000 );
	energieB->setFBgFarbe( 0xFF5555FF );
	energieB->setLinienRahmenFarbe( 0xFF0000FF );
	energieB->setLinienRahmenBreite( 1 );
	energieB->setFRFarbe( 0xFF0000FF );
	energieB->setFRBreite( 1 );
	energieB->setStyle( FBalken::Style::Sichtbar | FBalken::Style::L_R | FBalken::Style::Hintergrund | FBalken::Style::FFarbe | FBalken::Style::Rahmen | FBalken::Style::FRahmen );
	reparatur = initTextFeld( 5, 80, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
	akkuLeistung = initTextFeld( 5, 105, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
	wendigkeit = initTextFeld( 5, 130, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
	beschleunigung = initTextFeld( 5, 155, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
    antriebEffizienz = initTextFeld( 5, 180, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
    laserIntensitt = initTextFeld( 5, 205, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
	laserEffizienz = initTextFeld( 5, 230, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
	laserTempo = initTextFeld( 5, 255, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
	netzwerk = initTextFeld( 5, 280, 165, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::Mehrfarbig | TextFeld::Style::VCenter, "" );
	stabilittSkill = initKnopf( 172, 30, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	energieSkill = initKnopf( 172, 55, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	reparaturSkill = initKnopf( 172, 80, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	akkuLeistungSkill = initKnopf( 172, 105, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	wendigkeitSkill = initKnopf( 172, 130, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	beschleunigungSkill = initKnopf( 172, 155, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
    antriebEffizienzSkill = initKnopf( 172, 180, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
    laserIntensittSkill = initKnopf( 172, 205, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	laserEffizienzSkill = initKnopf( 172, 230, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	laserTempoSkill = initKnopf( 172, 255, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	netzwerkSkill = initKnopf( 172, 280, 20, 20, zSchrift, Knopf::Style::Sichtbar, "+" );
	stabilittSkill->removeStyle( Knopf::Style::Erlaubt );
	energieSkill->removeStyle( Knopf::Style::Erlaubt );
	reparaturSkill->removeStyle( Knopf::Style::Erlaubt );
	akkuLeistungSkill->removeStyle( Knopf::Style::Erlaubt );
	wendigkeitSkill->removeStyle( Knopf::Style::Erlaubt );
	beschleunigungSkill->removeStyle( Knopf::Style::Erlaubt );
	laserIntensittSkill->removeStyle( Knopf::Style::Erlaubt );
	laserEffizienzSkill->removeStyle( Knopf::Style::Erlaubt );
	laserTempoSkill->removeStyle( Knopf::Style::Erlaubt );
	netzwerkSkill->removeStyle( Knopf::Style::Erlaubt );
    skillPoints = initTextFeld( 5, 305, 180, 20, zSchrift, TextFeld::Style::Sichtbar | TextFeld::Style::VCenter, "" );
	ref = 1;
}

// Destruktor
SpielerGUI::~SpielerGUI()
{
	ram->release();
	spieler->release();
	stabilitt->release();
	energie->release();
	stabilittB->release();
	energieB->release();
	reparatur->release();
	akkuLeistung->release();
	wendigkeit->release();
	beschleunigung->release();
    antriebEffizienz->release();
	laserIntensitt->release();
	laserEffizienz->release();
	laserTempo->release();
	netzwerk->release();
	stabilittSkill->release();
	energieSkill->release();
	reparaturSkill->release();
	akkuLeistungSkill->release();
	wendigkeitSkill->release();
	beschleunigungSkill->release();
    antriebEffizienzSkill->release();
	laserIntensittSkill->release();
	laserEffizienzSkill->release();
	laserTempoSkill->release();
	netzwerkSkill->release();
    skillPoints->release();
}

// nicht constant
void SpielerGUI::update( Spieler *zSpieler )
{
	spieler->setText( zSpieler->name->getText() );
	spieler->setSchriftFarbe( zSpieler->current.farbe );
	Text txt;
	txt.setPrecision( getStellen( zSpieler->current.stabilitt ) + 2 );
	txt = zSpieler->current.stabilitt;
	txt += "/";
	txt.setPrecision( getStellen( zSpieler->current.maxStabilitt ) + 2 );
	txt += zSpieler->current.maxStabilitt;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->maxStabilitt ) + 2 );
	txt += zSpieler->team->maxStabilitt;
	txt += ")";
	stabilitt->setText( txt );
	stabilittB->reset();
	stabilittB->setAktionAnzahl( (int)( zSpieler->current.maxStabilitt + zSpieler->team->maxStabilitt ) );
	stabilittB->aktionPlus( (int)( zSpieler->current.stabilitt ) );
	txt.setPrecision( getStellen( zSpieler->current.energie ) + 2 );
	txt = zSpieler->current.energie;
	txt += "/";
	txt.setPrecision( getStellen( zSpieler->current.maxEnergie ) + 2 );
	txt += zSpieler->current.maxEnergie;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->maxEnergie ) + 2 );
	txt += zSpieler->team->maxEnergie;
	txt += ")";
	energie->setText( txt );
	energieB->reset();
	energieB->setAktionAnzahl( (int)( zSpieler->current.maxEnergie + zSpieler->team->maxEnergie ) );
	energieB->aktionPlus( (int)( zSpieler->current.energie ) );
	txt = "Reparatur:";
	txt.setPrecision( getStellen( zSpieler->current.reparatur ) + 2 );
	txt += zSpieler->current.reparatur;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->reparatur ) + 2 );
	txt += zSpieler->team->reparatur;
	txt += ")";
	reparatur->setText( txt );
	txt = "Akku:";
	txt.setPrecision( getStellen( zSpieler->current.akkuLeistung ) + 2 );
	txt += zSpieler->current.akkuLeistung;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->akkuLeistung ) + 2 );
	txt += zSpieler->team->akkuLeistung;
	txt += ")";
	akkuLeistung->setText( txt );
	txt = "Wendigkeit:";
	txt.setPrecision( getStellen( zSpieler->current.wendigkeit ) + 2 );
	txt += zSpieler->current.wendigkeit;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->wendigkeit ) + 2 );
	txt += zSpieler->team->wendigkeit;
	txt += ")";
	wendigkeit->setText( txt );
	txt = "Beschleunigung:";
	txt.setPrecision( getStellen( zSpieler->current.beschleunigung ) + 2 );
	txt += zSpieler->current.beschleunigung;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->beschleunigung ) + 2 );
	txt += zSpieler->team->beschleunigung;
	txt += ")";
	beschleunigung->setText( txt );
	txt = "Antrieb effizienz:";
	txt.setPrecision( getStellen( zSpieler->current.antriebEffizienz ) + 2 );
	txt += zSpieler->current.antriebEffizienz;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->antriebEffizienz ) + 2 );
	txt += zSpieler->team->antriebEffizienz;
	txt += ")";
    antriebEffizienz->setText( txt );
    txt = "Laser intensitt:";
    txt.setPrecision( getStellen( zSpieler->current.laserIntensitt ) + 2 );
    txt += zSpieler->current.laserIntensitt;
    txt += "\r0xFF00FF00(+";
    txt.setPrecision( getStellen( zSpieler->team->laserIntensitt ) + 2 );
    txt += zSpieler->team->laserIntensitt;
    txt += ")";
	laserIntensitt->setText( txt );
	txt = "Laser effizienz:";
	txt.setPrecision( getStellen( zSpieler->current.laserEffizienz ) + 2 );
	txt += zSpieler->current.laserEffizienz;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->laserEffizienz ) + 2 );
	txt += zSpieler->team->laserEffizienz;
	txt += ")";
	laserEffizienz->setText( txt );
	txt = "Laser tempo:";
	txt.setPrecision( getStellen( zSpieler->current.laserTempo ) + 2 );
	txt += zSpieler->current.laserTempo;
	txt += "\r0xFF00FF00(+";
	txt.setPrecision( getStellen( zSpieler->team->laserTempo ) + 2 );
	txt += zSpieler->team->laserTempo;
	txt += ")";
	laserTempo->setText( txt );
	txt = "Netzwerk:";
	txt.setPrecision( getStellen( zSpieler->current.netzwerk ) + 2 );
	txt += zSpieler->current.netzwerk;
	netzwerk->setText( txt );
	stabilittSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	energieSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	reparaturSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	akkuLeistungSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	wendigkeitSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	beschleunigungSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
    antriebEffizienzSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
    laserIntensittSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	laserEffizienzSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	laserTempoSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
	netzwerkSkill->setStyle( Knopf::Style::Erlaubt, zSpieler->hatSkill() );
    skillPoints->setText( Text( zSpieler->skillPunkte ) += " Punkte" );
}

int SpielerGUI::doMausEreignis( MausEreignis &me )
{
	me.mx -= ram->getX();
	me.my -= ram->getY();
	if( me.mx < 0 || me.my < 0 )
		return -1;
	int aktion = me.verarbeitet;
	stabilittSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 2;
	energieSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 3;
	reparaturSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 4;
    antriebEffizienzSkill->doMausEreignis( me );
    if( !aktion && me.verarbeitet && me.id == ME_RLinks )
        aktion = 12;
	laserIntensittSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 5;
	laserEffizienzSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 6;
	laserTempoSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 7;
	beschleunigungSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 8;
	wendigkeitSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 9;
	netzwerkSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 10;
	akkuLeistungSkill->doMausEreignis( me );
	if( !aktion && me.verarbeitet && me.id == ME_RLinks )
		aktion = 11;
	me.mx += ram->getX();
	me.my += ram->getY();
	if( aktion > 1 )
		return aktion - 2;
	return -1;
}

bool SpielerGUI::tick( double tickVal )
{
	bool ret = stabilittSkill->tick( tickVal );
	ret |= energieSkill->tick( tickVal );
	ret |= reparaturSkill->tick( tickVal );
	ret |= akkuLeistungSkill->tick( tickVal );
	ret |= wendigkeitSkill->tick( tickVal );
	ret |= beschleunigungSkill->tick( tickVal );
    ret |= antriebEffizienzSkill->tick( tickVal );
	ret |= laserIntensittSkill->tick( tickVal );
	ret |= laserEffizienzSkill->tick( tickVal );
	ret |= laserTempoSkill->tick( tickVal );
	ret |= netzwerkSkill->tick( tickVal );
	return ret;
}

void SpielerGUI::render( Bild &zRObj )
{
	zRObj.alphaRegion( ram->getX() + 1, ram->getY() + 1, ram->getBreite() - 2, ram->getHeight() - 2, 0xA0000000 );
	ram->render( zRObj );
	if( !zRObj.setDrawOptions( ram->getPosition() + Punkt( 1, 1 ), ram->getSize() - Punkt( 2, 2 ) ) )
		return;
	spieler->render( zRObj );
	stabilittB->render( zRObj );
	stabilitt->render( zRObj );
	stabilittSkill->render( zRObj );
	energieB->render( zRObj );
	energie->render( zRObj );
	energieSkill->render( zRObj );
	reparatur->render( zRObj );
	reparaturSkill->render( zRObj );
	akkuLeistung->render( zRObj );
	akkuLeistungSkill->render( zRObj );
	wendigkeit->render( zRObj );
	wendigkeitSkill->render( zRObj );
	beschleunigung->render( zRObj );
	beschleunigungSkill->render( zRObj );
    antriebEffizienz->render( zRObj );
    antriebEffizienzSkill->render( zRObj );
	laserIntensitt->render( zRObj );
	laserIntensittSkill->render( zRObj );
	laserEffizienz->render( zRObj );
	laserEffizienzSkill->render( zRObj );
	laserTempo->render( zRObj );
	laserTempoSkill->render( zRObj );
	netzwerk->render( zRObj );
	netzwerkSkill->render( zRObj );
    skillPoints->render( zRObj );
	zRObj.releaseDrawOptions();
}

// Reference Counting
SpielerGUI *SpielerGUI::getThis()
{
	ref++;
	return this;
}

SpielerGUI *SpielerGUI::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}